//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int MaeDevLength = 14;
extern int Price        = PRICE_CLOSE;

double ma[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,ma); return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
      double dev   = iATR(NULL,0,MaeDevLength,i+1);
      double map   = ma[i+1];
         if (i>Bars-2) map=price;
      
         //
         //
         //
         //
         //
         
         double mae = iMae(price,map,MaeDevLength,i);
         double alpha;
         if (dev!=0)
               alpha = MathMin(mae/dev,1);
         else  alpha = 1;
         ma[i] = ma[i+1]+alpha*(iMA(NULL,0,1,0,MODE_SMA,Price,i)-ma[i+1]);
   }
   return(0);           
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double workMae[][2];
double iMae(double price, double value, double length, int i)
{
   if (ArrayRange(workMae,0)!=Bars) ArrayResize(workMae,Bars); i = Bars-i-1;
   
      workMae[i][0] = price;
      workMae[i][1] = value;

   double mae = 0; for (int k=0; k<length; k++) mae += MathAbs(workMae[i-k][0]-workMae[i-k][1]); 
   return(mae / length);
}